/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package rabbitmqfastmessagingproducertest;

/**
 *
 * @author alter
 */


import com.rabbitmq.client.AMQP;
import com.rabbitmq.client.Channel;
import com.rabbitmq.client.ConnectionFactory;
import com.rabbitmq.client.Connection;
import com.rabbitmq.client.ConnectionParameters;
import com.rabbitmq.client.QueueingConsumer;
import com.rabbitmq.client.Envelope;
import com.rabbitmq.client.ShutdownSignalException;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

public class FastMessagingClientConsumer extends Thread {

    private final String HOSTNAME = "altair.tcontest.ru";
    private int THREAD_ID;
    private int MSG_COUNT = 10000;
    
    private Connection connection;
    private Channel channel;

    
    public FastMessagingClientConsumer() {
        try {

            ConnectionParameters params = new ConnectionParameters();

            params.setUsername("guest");
            params.setPassword("guest");
            params.setVirtualHost("/");
            params.setRequestedHeartbeat(10);
            // params.setRequestedFrameMax(128);

            ConnectionFactory factory = new ConnectionFactory(params);
            this.connection = factory.newConnection(this.HOSTNAME, AMQP.PROTOCOL.PORT);
            this.channel = connection.createChannel();

        } catch (IOException ex) {
            Logger.getLogger(FastMessagingProducer.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    public void setThreadId( int id) {
        this.THREAD_ID = id;
    }
    
    public int getThreadId() {
        return this.THREAD_ID;
    }
    
    @Override
    public void run()  {
        
        try {

            System.out.println("CLIENT_CONSUMER_THREAD_ID: " + this.THREAD_ID + " TIME: " + System.currentTimeMillis() + " START");

            
            int ticket = this.channel.accessRequest("/data");           
            
            String exchange = "game.football.events" ;
            String topic = "game.football.events." + THREAD_ID ;
            channel.exchangeDeclare(ticket, exchange, "topic");
            channel.queueDeclare(ticket, topic);
            
            channel.queueBind(ticket, topic, exchange, topic);
            
            QueueingConsumer consumer = new QueueingConsumer(channel);         
            channel.basicConsume(ticket, topic, true, consumer);
            
            Thread.sleep(5000);

            //while (true) {
            for( int i = 0; i < MSG_COUNT; i++) {
                QueueingConsumer.Delivery delivery = consumer.nextDelivery();
                Envelope envelope = delivery.getEnvelope();
                System.out.println("CLIENT_CONSUMER_THREAD_ID: " + this.THREAD_ID  + " TIME: " + System.currentTimeMillis() + " " + new String(delivery.getBody()) ) ;
                channel.basicAck(envelope.getDeliveryTag(), false);
            }
           
            channel.close(200, "BYE");
            connection.close(200, "BYE");

            System.out.println("CLIENT_CONSUMER_THREAD_ID: " + this.THREAD_ID  + " TIME: " + System.currentTimeMillis() + " STOP");
        
        } catch (ShutdownSignalException ex) {
            Logger.getLogger(FastMessagingClientConsumer.class.getName()).log(Level.SEVERE, null, ex);
        } catch (InterruptedException ex) {
            Logger.getLogger(FastMessagingProducer.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(FastMessagingProducer.class.getName()).log(Level.SEVERE, null, ex);
        }

        
    }
    
}
