/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package rabbitmqfastmessagingproducertest;

/**
 *
 * @author alter
 */

import com.rabbitmq.client.AMQP;
import com.rabbitmq.client.Channel;
import com.rabbitmq.client.ConnectionFactory;
import com.rabbitmq.client.Connection;
import com.rabbitmq.client.ConnectionParameters;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

public class FastMessagingProducer extends Thread {

    private final String HOSTNAME = "altair.tcontest.ru";
    private int THREAD_ID;
    private int MSG_COUNT = 10000;
    private int MSG_FREQ = 100;

    private Connection connection;
    private Channel channel;

    
    public FastMessagingProducer() {
        try {

            ConnectionParameters params = new ConnectionParameters();

            params.setUsername("guest");
            params.setPassword("guest");
            params.setVirtualHost("/");
            params.setRequestedHeartbeat(10);
            // params.setRequestedFrameMax(128);

            ConnectionFactory factory = new ConnectionFactory(params);
            this.connection = factory.newConnection(this.HOSTNAME, AMQP.PROTOCOL.PORT);
            this.channel = connection.createChannel();

        } catch (IOException ex) {
            Logger.getLogger(FastMessagingProducer.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }

    public void setThreadId( int id) {
        this.THREAD_ID = id;
    }
    
    public int getThreadId() {
        return this.THREAD_ID;
    }
    
    @Override
    @SuppressWarnings("static-access")
    public void run()  {
        
        try {

            System.out.println("CLIENT_PRODUCER_THREAD_ID: " + this.THREAD_ID + " TIME: " + System.currentTimeMillis() + " START");

            int ticket = this.channel.accessRequest("/data");           
            //channel.queueDeclare(ticket, "EventsQueue");
            String exchange = "game.football.events" ;
            String topic = "game.football.events." + THREAD_ID ;
            this.channel.exchangeDeclare(ticket, exchange, "topic");
            
            
            Thread.sleep(7000);

            for (int i = 0; i < MSG_COUNT; i++) {
                String message = "MESSAGE: " + i + " TIME: " + System.currentTimeMillis();
                //channel.basicPublish(ticket, "", "EventsQueue", null, message.getBytes());
                
                this.channel.basicPublish(ticket, exchange, topic, null, message.getBytes());
                // this.channel.basicPublish(ticket, exchange, topic, false, true, null, message.getBytes());
                
                System.out.println("CLIENT_PRODUCER_THREAD_ID: " + this.THREAD_ID  + " TIME: "+ System.currentTimeMillis() + " " + message);
                Thread.sleep(MSG_FREQ);
            }
            
            this.channel.close(200, "BYE");
            this.connection.close(200, "BYE");

            System.out.println("CLIENT_PRODUCER_THREAD_ID: " + this.THREAD_ID  + " TIME: " + System.currentTimeMillis() + " STOP");
        
        } catch (InterruptedException ex) {
            Logger.getLogger(FastMessagingProducer.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(FastMessagingProducer.class.getName()).log(Level.SEVERE, null, ex);
        }

        
    }
    
}
